// Generated by CoffeeScript 1.6.3
/*

  (S)ync - simply serialize async calls
  
  c) 2013 Sebastian Glaser <anx@ulzq.de>

  This file is part of the ync project.

  ync is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2, or (at your option)
  any later version.

  ync is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this software; see the file COPYING.  If not, write to
  the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
  Boston, MA 02111-1307 USA

  http://www.gnu.org/licenses/gpl.html
*/

var Join, Sync, cp, sequence, tests, _ref;

_ref = require('./ync'), Sync = _ref.Sync, Join = _ref.Join;

cp = require('child_process');

require('colors');

sequence = function() {
  return new Sync({
    fork: true,
    list_dir: function() {
      var _this = this;
      return cp.exec("echo SECRET_CODE", function(e, s, m) {
        return _this.proceed(s);
      });
    },
    sleep: function(data) {
      var _this = this;
      return cp.exec("sleep 0.5", function() {
        return _this.proceed(data);
      });
    },
    output: function(data) {
      return this.proceed(data);
    }
  });
};

tests = new Sync({
  fork: true,
  start: function() {
    this.count = 0;
    this.success = 0;
    return this.proceed();
  },
  chain: function() {
    var stack;
    stack = sequence();
    stack.on('done', function(data) {
      tests.count++;
      if (data.trim() === "SECRET_CODE") {
        tests.success++;
        return console.log("Test success:".green, "simple_chain");
      } else {
        return console.log("Test fail:".red, "simple_chain");
      }
    });
    return this.proceed();
  },
  insertion: function() {
    var stack,
      _this = this;
    stack = sequence();
    stack.insertAfter("sleep", "inject", function(data) {
      return this.proceed(data + " and stuff");
    });
    tests.count++;
    return stack.on('done', function(data) {
      if (data.trim() === "SECRET_CODE\n and stuff") {
        tests.success++;
        console.log("Test success:".green, "insertion");
      } else {
        console.log("Test fail:".red, "insertion");
      }
      return _this.proceed();
    });
  },
  done: function() {
    this.count++;
    this.success++;
    console.log("Test success:".green, "nesting");
    if (this.count === this.success) {
      console.log("All tests succeeded:".yellow, this.success.toString().green, '/', this.count.toString().yellow);
      return process.exit(0);
    } else {
      console.log("Some tests failed:".yellow, this.success.toString().red, '/', this.count.toString().yellow);
      return process.exit(1);
    }
  }
});
